declare namespace java {
    namespace nio {
        namespace channels {
            // @ts-ignore
            interface WritableByteChannel {
                /**
                 * Writes a sequence of bytes to this channel from the given buffer.
                 * <p> An attempt is made to write up to <i>r</i> bytes to the channel,
                 * where <i>r</i> is the number of bytes remaining in the buffer, that is,
                 * <tt>src.remaining()</tt>, at the moment this method is invoked.
                 * <p> Suppose that a byte sequence of length <i>n</i> is written, where
                 * <tt>0</tt>&nbsp;<tt>&lt;=</tt>&nbsp;<i>n</i>&nbsp;<tt>&lt;=</tt>&nbsp;<i>r</i>.
                 * This byte sequence will be transferred from the buffer starting at index
                 * <i>p</i>, where <i>p</i> is the buffer's position at the moment this
                 * method is invoked; the index of the last byte written will be
                 * <i>p</i>&nbsp;<tt>+</tt>&nbsp;<i>n</i>&nbsp;<tt>-</tt>&nbsp;<tt>1</tt>.
                 * Upon return the buffer's position will be equal to
                 * <i>p</i>&nbsp;<tt>+</tt>&nbsp;<i>n</i>; its limit will not have changed.
                 * <p> Unless otherwise specified, a write operation will return only after
                 * writing all of the <i>r</i> requested bytes.  Some types of channels,
                 * depending upon their state, may write only some of the bytes or possibly
                 * none at all.  A socket channel in non-blocking mode, for example, cannot
                 * write any more bytes than are free in the socket's output buffer.
                 * <p> This method may be invoked at any time.  If another thread has
                 * already initiated a write operation upon this channel, however, then an
                 * invocation of this method will block until the first operation is
                 * complete. </p>
                 */
                // @ts-ignore
                 write(src: java.nio.ByteBuffer): number;
            }
        }
    }
}
